/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

#ifdef ENABLE_CHECKING
  memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
#endif

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 1636:
    case 1635:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 1226:  /* altivec_stvrxl */
    case 1225:  /* altivec_stvrx */
    case 1224:  /* altivec_stvlxl */
    case 1223:  /* altivec_stvlx */
    case 1212:  /* altivec_stvxl */
    case 1211:  /* altivec_stvx_v2di */
    case 1210:  /* altivec_stvx_v2df */
    case 1209:  /* altivec_stvx_v4sf */
    case 1208:  /* altivec_stvx_v16qi */
    case 1207:  /* altivec_stvx_v8hi */
    case 1206:  /* altivec_stvx_v4si */
    case 1205:  /* altivec_lvx_v2di */
    case 1204:  /* altivec_lvx_v2df */
    case 1203:  /* altivec_lvx_v4sf */
    case 1202:  /* altivec_lvx_v16qi */
    case 1201:  /* altivec_lvx_v8hi */
    case 1200:  /* altivec_lvx_v4si */
    case 1199:  /* altivec_lvxl */
    case 1198:  /* *altivec_lvesfx */
    case 1197:  /* altivec_lvebx */
    case 1196:  /* altivec_lvehx */
    case 1195:  /* altivec_lvewx */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 1192:  /* altivec_dststt */
    case 1191:  /* altivec_dstst */
    case 1190:  /* altivec_dstt */
    case 1189:  /* altivec_dst */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 2));
      break;

    case 1188:  /* altivec_dss */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 1184:  /* altivec_vcmpbfp_p */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1036:  /* altivec_vmhraddshs */
    case 1035:  /* altivec_vmhaddshs */
    case 1020:  /* altivec_vmsumshs */
    case 1019:  /* altivec_vmsumuhs */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 1154:  /* altivec_vctsxs */
    case 1153:  /* altivec_vctuxs */
    case 1125:  /* altivec_vsumsws */
    case 1124:  /* altivec_vsum2sws */
    case 1123:  /* altivec_vsum4sbs */
    case 1122:  /* altivec_vsum4shs */
    case 1121:  /* altivec_vsum4ubs */
    case 1104:  /* altivec_vpkswus */
    case 1103:  /* altivec_vpkuwus */
    case 1102:  /* altivec_vpkshus */
    case 1101:  /* altivec_vpkuhus */
    case 1100:  /* altivec_vpkswss */
    case 1099:  /* altivec_vpkshss */
    case 978:  /* altivec_vsubsbs */
    case 977:  /* altivec_vsubshs */
    case 976:  /* altivec_vsubsws */
    case 975:  /* altivec_vsububs */
    case 974:  /* altivec_vsubuhs */
    case 973:  /* altivec_vsubuws */
    case 967:  /* altivec_vaddsbs */
    case 966:  /* altivec_vaddshs */
    case 965:  /* altivec_vaddsws */
    case 964:  /* altivec_vaddubs */
    case 963:  /* altivec_vadduhs */
    case 962:  /* altivec_vadduws */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 956:  /* *restore_vregs_di_r12 */
    case 955:  /* *restore_vregs_si_r12 */
    case 954:  /* *restore_vregs_di_r11 */
    case 953:  /* *restore_vregs_si_r11 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0), 1));
      break;

    case 952:  /* *save_vregs_di_r12 */
    case 951:  /* *save_vregs_si_r12 */
    case 950:  /* *save_vregs_di_r11 */
    case 949:  /* *save_vregs_si_r11 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 1));
      break;

    case 948:  /* *set_vrsave_internal */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 939:  /* *vsx_reduc_smax_v4sf_scalar */
    case 938:  /* *vsx_reduc_smin_v4sf_scalar */
    case 937:  /* *vsx_reduc_splus_v4sf_scalar */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 936:  /* *vsx_reduc_smax_v2df_scalar */
    case 935:  /* *vsx_reduc_smin_v2df_scalar */
    case 934:  /* *vsx_reduc_splus_v2df_scalar */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1);
      recog_data.dup_num[1] = 1;
      break;

    case 933:  /* *vsx_reduc_smax_v4sf */
    case 932:  /* *vsx_reduc_smin_v4sf */
    case 931:  /* *vsx_reduc_splus_v4sf */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 930:  /* *vsx_reduc_smax_v2df */
    case 929:  /* *vsx_reduc_smin_v2df */
    case 928:  /* *vsx_reduc_splus_v2df */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[1] = 1;
      break;

    case 1129:  /* altivec_vspltsf */
    case 1128:  /* altivec_vspltw */
    case 1127:  /* altivec_vsplth */
    case 1126:  /* altivec_vspltb */
    case 916:  /* vsx_xxspltw_v4si */
    case 915:  /* vsx_xxspltw_v4sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      break;

    case 912:  /* vsx_xxpermdi2_v2di_1 */
    case 911:  /* vsx_xxpermdi2_v2df_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 910:  /* vsx_extract_v4sf */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 907:  /* vsx_extract_v2di */
    case 906:  /* vsx_extract_v2df */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 1218:  /* vperm_v16qiv8hi */
    case 1217:  /* vperm_v8hiv4si */
    case 1165:  /* altivec_vsldoi_ti */
    case 1164:  /* altivec_vsldoi_v2di */
    case 1163:  /* altivec_vsldoi_v2df */
    case 1162:  /* altivec_vsldoi_v4sf */
    case 1161:  /* altivec_vsldoi_v16qi */
    case 1160:  /* altivec_vsldoi_v8hi */
    case 1159:  /* altivec_vsldoi_v4si */
    case 1147:  /* altivec_vperm_ti_uns */
    case 1146:  /* altivec_vperm_v2di_uns */
    case 1145:  /* altivec_vperm_v2df_uns */
    case 1144:  /* altivec_vperm_v4sf_uns */
    case 1143:  /* altivec_vperm_v16qi_uns */
    case 1142:  /* altivec_vperm_v8hi_uns */
    case 1141:  /* altivec_vperm_v4si_uns */
    case 1140:  /* altivec_vperm_ti */
    case 1139:  /* altivec_vperm_v2di */
    case 1138:  /* altivec_vperm_v2df */
    case 1137:  /* altivec_vperm_v4sf */
    case 1136:  /* altivec_vperm_v16qi */
    case 1135:  /* altivec_vperm_v8hi */
    case 1134:  /* altivec_vperm_v4si */
    case 1037:  /* altivec_vmladduhm */
    case 1018:  /* altivec_vmsumshm */
    case 1017:  /* altivec_vmsummbm */
    case 1016:  /* altivec_vmsummhm */
    case 1015:  /* altivec_vmsumubm */
    case 1014:  /* altivec_vmsumuhm */
    case 927:  /* vsx_xxsldwi_ti */
    case 926:  /* vsx_xxsldwi_v2df */
    case 925:  /* vsx_xxsldwi_v4sf */
    case 924:  /* vsx_xxsldwi_v2di */
    case 923:  /* vsx_xxsldwi_v4si */
    case 922:  /* vsx_xxsldwi_v8hi */
    case 921:  /* vsx_xxsldwi_v16qi */
    case 905:  /* vsx_set_v2di */
    case 904:  /* vsx_set_v2df */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 1095:  /* *altivec_andcti3 */
    case 1094:  /* *altivec_andcv2di3 */
    case 1093:  /* *altivec_andcv2df3 */
    case 1092:  /* *altivec_andcv4sf3 */
    case 1091:  /* *altivec_andcv16qi3 */
    case 1090:  /* *altivec_andcv8hi3 */
    case 1089:  /* *altivec_andcv4si3 */
    case 900:  /* *vsx_andcti3 */
    case 899:  /* *vsx_andcv2df3 */
    case 898:  /* *vsx_andcv4sf3 */
    case 897:  /* *vsx_andcv2di3 */
    case 896:  /* *vsx_andcv4si3 */
    case 895:  /* *vsx_andcv8hi3 */
    case 894:  /* *vsx_andcv16qi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 1183:  /* *altivec_vcmpgefp_p */
    case 1182:  /* *altivec_vcmpgtfp_p */
    case 1181:  /* *altivec_vcmpeqfp_p */
    case 1180:  /* *altivec_vcmpgtub_p */
    case 1179:  /* *altivec_vcmpgtuh_p */
    case 1178:  /* *altivec_vcmpgtuw_p */
    case 1177:  /* *altivec_vcmpgtsb_p */
    case 1176:  /* *altivec_vcmpgtsh_p */
    case 1175:  /* *altivec_vcmpgtsw_p */
    case 1174:  /* *altivec_vcmpequb_p */
    case 1173:  /* *altivec_vcmpequh_p */
    case 1172:  /* *altivec_vcmpequw_p */
    case 795:  /* *vsx_ge_v2df_p */
    case 794:  /* *vsx_ge_v4sf_p */
    case 793:  /* *vsx_gt_v2df_p */
    case 792:  /* *vsx_gt_v4sf_p */
    case 791:  /* *vsx_eq_v2df_p */
    case 790:  /* *vsx_eq_v4sf_p */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 707:  /* store_conditionaldi */
    case 706:  /* store_conditionalsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 698:  /* *lwsync */
    case 697:  /* *hwsync */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 694:  /* rs6000_get_timebase_ppc32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 691:  /* prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 703:  /* loadsync_di */
    case 702:  /* loadsync_si */
    case 701:  /* loadsync_hi */
    case 700:  /* loadsync_qi */
    case 690:  /* eh_set_lr_di */
    case 689:  /* eh_set_lr_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 688:  /* *return_and_restore_fpregs_aix_di_r1 */
    case 687:  /* *return_and_restore_fpregs_aix_si_r1 */
    case 686:  /* *return_and_restore_fpregs_aix_di_r11 */
    case 685:  /* *return_and_restore_fpregs_aix_si_r11 */
    case 684:  /* *return_and_restore_fpregs_di_r1 */
    case 683:  /* *return_and_restore_fpregs_si_r1 */
    case 682:  /* *return_and_restore_fpregs_di_r12 */
    case 681:  /* *return_and_restore_fpregs_si_r12 */
    case 680:  /* *return_and_restore_fpregs_di_r11 */
    case 679:  /* *return_and_restore_fpregs_si_r11 */
    case 678:  /* *return_and_restore_gpregs_di_r1 */
    case 677:  /* *return_and_restore_gpregs_si_r1 */
    case 676:  /* *return_and_restore_gpregs_di_r12 */
    case 675:  /* *return_and_restore_gpregs_si_r12 */
    case 674:  /* *return_and_restore_gpregs_di_r11 */
    case 673:  /* *return_and_restore_gpregs_si_r11 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 1));
      break;

    case 672:  /* *restore_gpregs_di_r1 */
    case 671:  /* *restore_gpregs_si_r1 */
    case 670:  /* *restore_gpregs_di_r12 */
    case 669:  /* *restore_gpregs_si_r12 */
    case 668:  /* *restore_gpregs_di_r11 */
    case 667:  /* *restore_gpregs_si_r11 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 1));
      break;

    case 666:  /* *return_internal_di */
    case 665:  /* *return_internal_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 661:  /* stack_tie */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      break;

    case 660:  /* *save_fpregs_di_r1 */
    case 659:  /* *save_fpregs_si_r1 */
    case 658:  /* *save_fpregs_di_r12 */
    case 657:  /* *save_fpregs_si_r12 */
    case 656:  /* *save_fpregs_di_r11 */
    case 655:  /* *save_fpregs_si_r11 */
    case 654:  /* *save_gpregs_di_r1 */
    case 653:  /* *save_gpregs_si_r1 */
    case 652:  /* *save_gpregs_di_r12 */
    case 651:  /* *save_gpregs_si_r12 */
    case 650:  /* *save_gpregs_di_r11 */
    case 649:  /* *save_gpregs_si_r11 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 1));
      break;

    case 664:  /* *lmw */
    case 648:  /* *stmw */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 662:  /* *movsi_to_cr */
    case 646:  /* *movesi_from_cr_one */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 645:  /* *rs6000.md:13409 */
    case 644:  /* *rs6000.md:13409 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 642:  /* *ctrdi_internal6 */
    case 641:  /* *ctrsi_internal6 */
    case 638:  /* *ctrdi_internal2 */
    case 637:  /* *ctrsi_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 640:  /* *ctrdi_internal5 */
    case 639:  /* *ctrsi_internal5 */
    case 636:  /* *ctrdi_internal1 */
    case 635:  /* *ctrsi_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 632:  /* *tablejumpdi_internal1 */
    case 631:  /* *tablejumpsi_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 630:  /* *indirect_jumpdi */
    case 629:  /* *indirect_jumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 626:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 625:  /* *rs6000.md:13046 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 624:  /* *cceq_rev_compare */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 623:  /* *rs6000.md:13013 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 622:  /* *cceq_ior_compare */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 619:  /* *rs6000.md:12953 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 621:  /* *rs6000.md:12968 */
    case 620:  /* *rs6000.md:12968 */
    case 618:  /* *rs6000.md:12937 */
    case 617:  /* *rs6000.md:12937 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 616:  /* *rs6000.md:12922 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 605:  /* *rs6000.md:12816 */
    case 604:  /* *rs6000.md:12783 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 603:  /* *rs6000.md:12751 */
    case 602:  /* *rs6000.md:12719 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 601:  /* *plus_gt0di */
    case 600:  /* *plus_gt0si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 599:  /* *rs6000.md:12672 */
    case 575:  /* *rs6000.md:12381 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 598:  /* *rs6000.md:12636 */
    case 574:  /* *rs6000.md:12347 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 597:  /* *and_neg_geudi */
    case 596:  /* *and_neg_geusi */
    case 573:  /* *and_neg_leudi */
    case 572:  /* *and_neg_leusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 561:  /* *plus_ne0_di_compare */
    case 560:  /* *plus_ne0_si_compare */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 559:  /* *compare_plus_ne0_di_1 */
    case 558:  /* *compare_plus_ne0_si_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 557:  /* *compare_plus_ne0_di */
    case 556:  /* *compare_plus_ne0_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 540:  /* *rs6000.md:11754 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 539:  /* *rs6000.md:11724 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 538:  /* *rs6000.md:11693 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 537:  /* *rs6000.md:11679 */
    case 535:  /* *rs6000.md:11646 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 534:  /* *cmptf_internal2 */
    case 533:  /* *cmptf_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 6), 0));
      ro[9] = *(ro_loc[9] = &XEXP (XVECEXP (pat, 0, 7), 0));
      ro[10] = *(ro_loc[10] = &XEXP (XVECEXP (pat, 0, 8), 0));
      ro[11] = *(ro_loc[11] = &XEXP (XVECEXP (pat, 0, 9), 0));
      break;

    case 529:  /* *rs6000.md:11520 */
    case 528:  /* *rs6000.md:11510 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 523:  /* stack_protect_testdi */
    case 522:  /* stack_protect_testsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1186:  /* altivec_mfvscr */
    case 947:  /* get_vrsave_internal */
    case 696:  /* rs6000_mftb_di */
    case 695:  /* rs6000_mftb_si */
    case 647:  /* movesi_from_cr */
    case 517:  /* probe_stack_di */
    case 516:  /* probe_stack_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 502:  /* *call_value_nonlocal_sysv_securedi */
    case 501:  /* *call_value_nonlocal_sysv_securesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 496:  /* *call_nonlocal_sysv_securedi */
    case 495:  /* *call_nonlocal_sysv_securesi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 486:  /* call_value_indirect_aix64bit_nor11 */
    case 485:  /* call_value_indirect_aix32bit_nor11 */
    case 484:  /* call_value_indirect_aix64bit */
    case 483:  /* call_value_indirect_aix32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      break;

    case 482:  /* call_indirect_aix64bit_nor11 */
    case 481:  /* call_indirect_aix32bit_nor11 */
    case 480:  /* call_indirect_aix64bit */
    case 479:  /* call_indirect_aix32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 1));
      break;

    case 470:  /* load_toc_v4_PIC_3c */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 469:  /* load_toc_v4_PIC_3b */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      break;

    case 468:  /* load_toc_v4_PIC_2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1));
      break;

    case 467:  /* load_toc_v4_PIC_1b_normal */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (pat, 0, 1);
      recog_data.dup_num[0] = 1;
      break;

    case 466:  /* load_toc_v4_PIC_1_normal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1187:  /* altivec_dssall */
    case 699:  /* isync */
    case 643:  /* trap */
    case 634:  /* group_ending_nop */
    case 633:  /* nop */
    case 628:  /* simple_return */
    case 627:  /* return */
    case 515:  /* blockage */
    case 465:  /* load_toc_v4_pic_si */
      break;

    case 464:  /* load_toc_aix_di */
    case 463:  /* load_toc_aix_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      break;

    case 444:  /* *tls_ld_call_sysv64 */
    case 443:  /* *tls_ld_call_sysv32 */
    case 442:  /* *tls_ld_call_aix64 */
    case 441:  /* *tls_ld_call_aix32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 438:  /* tls_ld_sysvdi */
    case 437:  /* tls_ld_sysvsi */
    case 436:  /* tls_ld_aix64 */
    case 435:  /* tls_ld_aix32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 434:  /* *tls_gd_call_sysv64 */
    case 433:  /* *tls_gd_call_sysv32 */
    case 432:  /* *tls_gd_call_aix64 */
    case 431:  /* *tls_gd_call_aix32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      break;

    case 428:  /* tls_gd_sysvdi */
    case 427:  /* tls_gd_sysvsi */
    case 426:  /* tls_gd_aix64 */
    case 425:  /* tls_gd_aix32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 417:  /* *movqi_update2 */
    case 414:  /* *movhi_update3 */
    case 413:  /* *movhi_update2 */
    case 409:  /* *movsi_update2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 424:  /* *movdf_update2 */
    case 422:  /* *movsf_update4 */
    case 420:  /* *movsf_update2 */
    case 418:  /* *movqi_update3 */
    case 415:  /* *movhi_update4 */
    case 411:  /* movsi_update_stack */
    case 410:  /* movsi_update */
    case 407:  /* movdi_di_update_stack */
    case 406:  /* movdi_si_update_stack */
    case 405:  /* movdi_di_update */
    case 404:  /* movdi_si_update */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 402:  /* *rs6000.md:9263 */
    case 401:  /* *rs6000.md:9263 */
    case 400:  /* *rs6000.md:9238 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 399:  /* *rs6000.md:9207 */
    case 398:  /* *rs6000.md:9207 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 7), 0));
      break;

    case 397:  /* *rs6000.md:9169 */
    case 396:  /* *rs6000.md:9169 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 9), 0));
      break;

    case 395:  /* *rs6000.md:9126 */
    case 394:  /* *rs6000.md:9126 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 11), 0));
      break;

    case 393:  /* *stmsi3 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 392:  /* *stmsi4 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      break;

    case 391:  /* *stmsi5 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 1));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[3] = 1;
      break;

    case 390:  /* *stmsi6 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 1));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 1));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 6), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 6), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 0), 0), 0);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[4] = 1;
      break;

    case 389:  /* *stmsi7 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 1));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 1));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 6), 1));
      ro[9] = *(ro_loc[9] = &XEXP (XVECEXP (pat, 0, 7), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 7), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 6), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 0);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 0), 0), 0);
      recog_data.dup_num[4] = 1;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[5] = 1;
      break;

    case 388:  /* *stmsi8 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 1));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 1));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 6), 1));
      ro[9] = *(ro_loc[9] = &XEXP (XVECEXP (pat, 0, 7), 1));
      ro[10] = *(ro_loc[10] = &XEXP (XVECEXP (pat, 0, 8), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 8), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 7), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 6), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 0), 0), 0);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0), 0);
      recog_data.dup_num[4] = 1;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 0), 0), 0);
      recog_data.dup_num[5] = 1;
      recog_data.dup_loc[6] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[6] = 1;
      break;

    case 387:  /* *ldmsi3 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 386:  /* *ldmsi4 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[2] = 1;
      break;

    case 385:  /* *ldmsi5 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[3] = 1;
      break;

    case 384:  /* *ldmsi6 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[4] = 1;
      break;

    case 383:  /* *ldmsi7 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 6), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 6), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0), 0);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[4] = 1;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[5] = 1;
      break;

    case 382:  /* *ldmsi8 */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 5), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 6), 0));
      ro[9] = *(ro_loc[9] = &XEXP (XVECEXP (pat, 0, 7), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 7), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 6), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 5), 1), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0), 0);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0), 0);
      recog_data.dup_num[4] = 1;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[5] = 1;
      recog_data.dup_loc[6] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[6] = 1;
      break;

    case 521:  /* stack_protect_setdi */
    case 520:  /* stack_protect_setsi */
    case 374:  /* fix_trunc_helper */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 357:  /* *movdi_internal2 */
    case 356:  /* *movsi_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 1244:  /* *movtd_internal */
    case 1240:  /* *movdd_softfloat64 */
    case 1239:  /* *movdd_hardfloat64 */
    case 1238:  /* *movdd_hardfloat64_mfpgpr */
    case 1237:  /* *movdd_softfloat32 */
    case 1236:  /* *movdd_hardfloat32 */
    case 1228:  /* movsd_softfloat */
    case 1227:  /* movsd_hardfloat */
    case 946:  /* *altivec_movti */
    case 945:  /* *altivec_movv2di */
    case 944:  /* *altivec_movv2df */
    case 943:  /* *altivec_movv4sf */
    case 942:  /* *altivec_movv16qi */
    case 941:  /* *altivec_movv8hi */
    case 940:  /* *altivec_movv4si */
    case 726:  /* *vsx_movti */
    case 725:  /* *vsx_movv2df */
    case 724:  /* *vsx_movv4sf */
    case 723:  /* *vsx_movv2di */
    case 722:  /* *vsx_movv4si */
    case 721:  /* *vsx_movv8hi */
    case 720:  /* *vsx_movv16qi */
    case 472:  /* *tocrefdi */
    case 471:  /* *tocrefsi */
    case 381:  /* *movti_ppc64 */
    case 380:  /* *movti_string */
    case 379:  /* *movdi_internal64 */
    case 378:  /* *movdi_mfpgpr */
    case 377:  /* *movdi_internal32 */
    case 369:  /* *movtf_softfloat */
    case 368:  /* *movtf_internal */
    case 367:  /* *movdf_softfloat64 */
    case 366:  /* *movdf_hardfloat64 */
    case 365:  /* *movdf_hardfloat64_mfpgpr */
    case 364:  /* *movdf_softfloat32 */
    case 363:  /* *movdf_hardfloat32 */
    case 362:  /* *movsf_softfloat */
    case 361:  /* *movsf_hardfloat */
    case 360:  /* *movcc_internal1 */
    case 359:  /* *movqi_internal */
    case 358:  /* *movhi_internal */
    case 355:  /* *movsi_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 310:  /* umuldi3_highpart */
    case 309:  /* smuldi3_highpart */
    case 303:  /* umulsi3_highpart */
    case 302:  /* smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 276:  /* *roundu32df2_fprs */
    case 275:  /* *roundu32sf2_fprs */
    case 274:  /* *round32df2_fprs */
    case 273:  /* *round32sf2_fprs */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 271:  /* fctiwuz_df */
    case 270:  /* fctiwuz_sf */
    case 269:  /* fctiwz_df */
    case 268:  /* fctiwz_sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      break;

    case 261:  /* fix_truncdfsi2_internal */
    case 260:  /* fix_truncsfsi2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 375:  /* *fix_trunctfsi2_internal */
    case 257:  /* *floatunssidf2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 256:  /* *floatsidf2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 5), 0));
      break;

    case 1011:  /* *altivec_vselti_uns */
    case 1010:  /* *altivec_vselv2di_uns */
    case 1009:  /* *altivec_vselv2df_uns */
    case 1008:  /* *altivec_vselv4sf_uns */
    case 1007:  /* *altivec_vselv16qi_uns */
    case 1006:  /* *altivec_vselv8hi_uns */
    case 1005:  /* *altivec_vselv4si_uns */
    case 1004:  /* *altivec_vselti */
    case 1003:  /* *altivec_vselv2di */
    case 1002:  /* *altivec_vselv2df */
    case 1001:  /* *altivec_vselv4sf */
    case 1000:  /* *altivec_vselv16qi */
    case 999:  /* *altivec_vselv8hi */
    case 998:  /* *altivec_vselv4si */
    case 809:  /* *vsx_xxselti_uns */
    case 808:  /* *vsx_xxselv2df_uns */
    case 807:  /* *vsx_xxselv4sf_uns */
    case 806:  /* *vsx_xxselv2di_uns */
    case 805:  /* *vsx_xxselv4si_uns */
    case 804:  /* *vsx_xxselv8hi_uns */
    case 803:  /* *vsx_xxselv16qi_uns */
    case 802:  /* *vsx_xxselti */
    case 801:  /* *vsx_xxselv2df */
    case 800:  /* *vsx_xxselv4sf */
    case 799:  /* *vsx_xxselv2di */
    case 798:  /* *vsx_xxselv4si */
    case 797:  /* *vsx_xxselv8hi */
    case 796:  /* *vsx_xxselv16qi */
    case 245:  /* *fselsfdf4 */
    case 244:  /* *fseldfdf4 */
    case 229:  /* *fseldfsf4 */
    case 228:  /* *fselsfsf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 227:  /* *isel_reversed_unsigned_di */
    case 226:  /* *isel_reversed_unsigned_si */
    case 225:  /* *isel_reversed_signed_di */
    case 224:  /* *isel_reversed_signed_si */
    case 223:  /* isel_unsigned_di */
    case 222:  /* isel_unsigned_si */
    case 221:  /* isel_signed_di */
    case 220:  /* isel_signed_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 1152:  /* altivec_vcfsx */
    case 1151:  /* altivec_vcfux */
    case 1120:  /* altivec_vsro */
    case 1119:  /* altivec_vsr */
    case 1109:  /* altivec_vslo */
    case 1108:  /* altivec_vsl */
    case 1098:  /* altivec_vpkpx */
    case 1097:  /* altivec_vpkuwum */
    case 1096:  /* altivec_vpkuhum */
    case 1053:  /* vec_widen_smult_odd_v8hi */
    case 1052:  /* vec_widen_umult_odd_v8hi */
    case 1051:  /* vec_widen_smult_odd_v16qi */
    case 1050:  /* vec_widen_umult_odd_v16qi */
    case 1049:  /* vec_widen_smult_even_v8hi */
    case 1048:  /* vec_widen_umult_even_v8hi */
    case 1047:  /* vec_widen_smult_even_v16qi */
    case 1046:  /* vec_widen_umult_even_v16qi */
    case 985:  /* altivec_vcmpbfp */
    case 984:  /* altivec_vavgsb */
    case 983:  /* altivec_vavgsh */
    case 982:  /* altivec_vavgsw */
    case 981:  /* altivec_vavgub */
    case 980:  /* altivec_vavguh */
    case 979:  /* altivec_vavguw */
    case 972:  /* altivec_vsubcuw */
    case 961:  /* altivec_vaddcuw */
    case 903:  /* vsx_concat_v2sf */
    case 902:  /* vsx_concat_v2di */
    case 901:  /* vsx_concat_v2df */
    case 812:  /* vsx_copysignv2df3 */
    case 811:  /* vsx_copysignv4sf3 */
    case 810:  /* vsx_copysigndf3 */
    case 741:  /* *vsx_tdivv2df3_internal */
    case 740:  /* *vsx_tdivv4sf3_internal */
    case 739:  /* *vsx_tdivdf3_internal */
    case 693:  /* bpermd_di */
    case 692:  /* bpermd_si */
    case 663:  /* *mtcrfsi */
    case 519:  /* probe_stack_rangedi */
    case 518:  /* probe_stack_rangesi */
    case 462:  /* tls_tls_64 */
    case 461:  /* tls_tls_32 */
    case 460:  /* tls_got_tprel_64 */
    case 459:  /* tls_got_tprel_32 */
    case 458:  /* tls_tprel_lo_64 */
    case 457:  /* tls_tprel_lo_32 */
    case 456:  /* tls_tprel_ha_64 */
    case 455:  /* tls_tprel_ha_32 */
    case 454:  /* tls_tprel_64 */
    case 453:  /* tls_tprel_32 */
    case 452:  /* tls_got_dtprel_64 */
    case 451:  /* tls_got_dtprel_32 */
    case 450:  /* tls_dtprel_lo_64 */
    case 449:  /* tls_dtprel_lo_32 */
    case 448:  /* tls_dtprel_ha_64 */
    case 447:  /* tls_dtprel_ha_32 */
    case 446:  /* tls_dtprel_64 */
    case 445:  /* tls_dtprel_32 */
    case 430:  /* *tls_gd64 */
    case 429:  /* *tls_gd32 */
    case 354:  /* *movsi_got_internal */
    case 219:  /* copysigndf3_fcpsgn */
    case 218:  /* copysignsf3_fcpsgn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 1013:  /* *altivec_vnmsubfp */
    case 782:  /* *vsx_nfmsv2df4 */
    case 781:  /* *vsx_nfmsv4sf4 */
    case 780:  /* *vsx_nfmsdf4 */
    case 242:  /* *nfmsdf4_fpr */
    case 215:  /* *nfmssf4_fpr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 779:  /* *vsx_nfmav2df4 */
    case 778:  /* *vsx_nfmav4sf4 */
    case 777:  /* *vsx_nfmadf4 */
    case 241:  /* *nfmadf4_fpr */
    case 214:  /* *nfmasf4_fpr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 776:  /* *vsx_fmsv2df4 */
    case 775:  /* *vsx_fmsv4sf4 */
    case 774:  /* *vsx_fmsdf4 */
    case 240:  /* *fmsdf4_fpr */
    case 213:  /* *fmssf4_fpr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 325:  /* *rotldi3_internal15 */
    case 322:  /* *rotldi3_internal12 */
    case 319:  /* *rotldi3_internal9 */
    case 197:  /* *rs6000.md:4310 */
    case 194:  /* *rs6000.md:4231 */
    case 177:  /* *rotlsi3_internal12 */
    case 174:  /* *rotlsi3_internal9 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 324:  /* *rotldi3_internal14 */
    case 321:  /* *rotldi3_internal11 */
    case 318:  /* *rotldi3_internal8 */
    case 196:  /* *rs6000.md:4275 */
    case 193:  /* *rs6000.md:4196 */
    case 176:  /* *rotlsi3_internal11 */
    case 173:  /* *rotlsi3_internal8 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 323:  /* *rotldi3_internal13 */
    case 320:  /* *rotldi3_internal10 */
    case 317:  /* *rotldi3_internal7 */
    case 195:  /* *rs6000.md:4266 */
    case 192:  /* *rs6000.md:4187 */
    case 175:  /* *rotlsi3_internal10 */
    case 172:  /* *rotlsi3_internal7 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 613:  /* *plus_gtudi_compare */
    case 612:  /* *plus_gtusi_compare */
    case 593:  /* *rs6000.md:12577 */
    case 583:  /* *plus_ltudi_compare */
    case 582:  /* *plus_ltusi_compare */
    case 569:  /* *rs6000.md:12294 */
    case 547:  /* *plus_eqsi_compare */
    case 334:  /* *ashldi3_internal9 */
    case 331:  /* *ashldi3_internal6 */
    case 316:  /* *rotldi3_internal6 */
    case 191:  /* *rs6000.md:4154 */
    case 184:  /* *rs6000.md:3995 */
    case 171:  /* *rotlsi3_internal6 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 592:  /* *rs6000.md:12543 */
    case 568:  /* *rs6000.md:12262 */
    case 546:  /* *compare_plus_eqsi */
    case 333:  /* ashldi3_internal8 */
    case 330:  /* ashldi3_internal5 */
    case 315:  /* *rotldi3_internal5 */
    case 190:  /* *rs6000.md:4122 */
    case 183:  /* *rs6000.md:3963 */
    case 170:  /* *rotlsi3_internal5 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 611:  /* *plus_gtudi */
    case 610:  /* *plus_gtusi */
    case 591:  /* *plus_geudi */
    case 590:  /* *plus_geusi */
    case 581:  /* *plus_ltudi */
    case 580:  /* *plus_ltusi */
    case 567:  /* *plus_leudi */
    case 566:  /* *plus_leusi */
    case 545:  /* *plus_eqsi */
    case 332:  /* *ashldi3_internal7 */
    case 329:  /* *ashldi3_internal4 */
    case 314:  /* *rotldi3_internal4 */
    case 189:  /* *rs6000.md:4114 */
    case 182:  /* rlwinm */
    case 169:  /* *rotlsi3_internal4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1088:  /* *altivec_norti3 */
    case 1087:  /* *altivec_norv2di3 */
    case 1086:  /* *altivec_norv2df3 */
    case 1085:  /* *altivec_norv4sf3 */
    case 1084:  /* *altivec_norv16qi3 */
    case 1083:  /* *altivec_norv8hi3 */
    case 1082:  /* *altivec_norv4si3 */
    case 1045:  /* *altivec_vmrglsf */
    case 1044:  /* altivec_vmrglw */
    case 1043:  /* altivec_vmrglh */
    case 1042:  /* altivec_vmrglb */
    case 1041:  /* *altivec_vmrghsf */
    case 1040:  /* altivec_vmrghw */
    case 1039:  /* altivec_vmrghh */
    case 1038:  /* altivec_vmrghb */
    case 920:  /* vsx_xxmrglw_v4si */
    case 919:  /* vsx_xxmrglw_v4sf */
    case 918:  /* vsx_xxmrghw_v4si */
    case 917:  /* vsx_xxmrghw_v4sf */
    case 893:  /* *vsx_norti3 */
    case 892:  /* *vsx_norv2df3 */
    case 891:  /* *vsx_norv4sf3 */
    case 890:  /* *vsx_norv2di3 */
    case 889:  /* *vsx_norv4si3 */
    case 888:  /* *vsx_norv8hi3 */
    case 887:  /* *vsx_norv16qi3 */
    case 709:  /* *vec_reload_and_plus_di */
    case 708:  /* *vec_reload_and_plus_si */
    case 615:  /* *neg_gtudi */
    case 614:  /* *neg_gtusi */
    case 595:  /* *neg_geudi */
    case 594:  /* *neg_geusi */
    case 585:  /* *neg_ltudi */
    case 584:  /* *neg_ltusi */
    case 571:  /* *neg_leudi */
    case 570:  /* *neg_leusi */
    case 551:  /* *neg_eqdi */
    case 550:  /* *neg_eqsi */
    case 199:  /* *ashrsi3_64 */
    case 186:  /* *lshrsi3_64 */
    case 179:  /* *ashlsi3_64 */
    case 166:  /* *rotlsi3_64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 164:  /* *extzvdi_internal2 */
    case 161:  /* *extzvsi_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 2);
      recog_data.dup_num[2] = 3;
      break;

    case 163:  /* *extzvdi_internal1 */
    case 160:  /* *extzvsi_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1012:  /* *altivec_fmav4sf4 */
    case 773:  /* *vsx_fmav2df4 */
    case 772:  /* *vsx_fmav4sf4 */
    case 771:  /* *vsx_fmadf4 */
    case 239:  /* *fmadf4_fpr */
    case 212:  /* *fmasf4_fpr */
    case 162:  /* extzvdi_internal */
    case 159:  /* extzvsi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 155:  /* *insvsi_internal6 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 154:  /* *insvsi_internal5 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 153:  /* *insvsi_internal4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 158:  /* *insvdi_internal3 */
    case 157:  /* *insvdi_internal2 */
    case 152:  /* *insvsi_internal3 */
    case 151:  /* *insvsi_internal2 */
    case 150:  /* *insvsi_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 156:  /* insvdi_internal */
    case 149:  /* insvsi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 353:  /* *boolccdi3_internal3 */
    case 148:  /* *boolccsi3_internal3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 4;
      break;

    case 352:  /* *boolccdi3_internal2 */
    case 147:  /* *boolccsi3_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 351:  /* *boolccdi3_internal1 */
    case 146:  /* *boolccsi3_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 350:  /* *boolcdi3_internal3 */
    case 145:  /* *boolcsi3_internal3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 4;
      break;

    case 349:  /* *boolcdi3_internal2 */
    case 144:  /* *boolcsi3_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 348:  /* *boolcdi3_internal1 */
    case 143:  /* *boolcsi3_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 347:  /* *booldi3_internal3 */
    case 142:  /* *boolsi3_internal3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 4;
      break;

    case 346:  /* *booldi3_internal2 */
    case 141:  /* *boolsi3_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 345:  /* *booldi3_internal1 */
    case 140:  /* *boolsi3_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 344:  /* *anddi3_internal3_mc */
    case 138:  /* *andsi3_internal5_mc */
    case 137:  /* *andsi3_internal4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 343:  /* *anddi3_internal2_mc */
    case 136:  /* *andsi3_internal3_mc */
    case 135:  /* *andsi3_internal2_mc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 342:  /* anddi3_nomc */
    case 341:  /* anddi3_mc */
    case 133:  /* andsi3_nomc */
    case 132:  /* andsi3_mc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 117:  /* *bswapdi2_64bit */
    case 116:  /* *bswapdi2_ldbrx */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 1246:  /* trunctddd2 */
    case 553:  /* *ne0_di */
    case 552:  /* *ne0_si */
    case 373:  /* trunctfsf2_fprs */
    case 370:  /* *extenddftf2_internal */
    case 296:  /* *floatunsdisf2_mem */
    case 294:  /* floatdisf2_internal1 */
    case 293:  /* *floatdisf2_mem */
    case 291:  /* *floatunsdidf2_mem */
    case 289:  /* *floatdidf2_mem */
    case 265:  /* fixuns_truncdfsi2_stfiwx */
    case 264:  /* fixuns_truncsfsi2_stfiwx */
    case 259:  /* fix_truncdfsi2_stfiwx */
    case 258:  /* fix_truncsfsi2_stfiwx */
    case 253:  /* floatunssidf2_lfiwzx */
    case 252:  /* floatunssisf2_lfiwzx */
    case 248:  /* floatsidf2_lfiwax */
    case 247:  /* floatsisf2_lfiwax */
    case 118:  /* bswapdi2_32bit */
    case 113:  /* bswaphi2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1243:  /* *nabstd2_fpr */
    case 1235:  /* *nabsdd2_fpr */
    case 858:  /* *vsx_float_fix_df2 */
    case 857:  /* *vsx_float_fix_v2df2 */
    case 753:  /* vsx_nabsv2df2 */
    case 752:  /* vsx_nabsv4sf2 */
    case 751:  /* vsx_nabsdf2 */
    case 549:  /* *neg_eq0di */
    case 548:  /* *neg_eq0si */
    case 305:  /* *ashrdisi3_noppc64 */
    case 272:  /* *friz */
    case 232:  /* *nabsdf2_fpr */
    case 206:  /* *rs6000.md:4542 */
    case 114:  /* *bswapsi2_extenddi */
    case 112:  /* *bswaphi2_extendsi */
    case 111:  /* *bswaphi2_extenddi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 1230:  /* movsd_load */
    case 1229:  /* movsd_store */
    case 1222:  /* altivec_lvrxl */
    case 1221:  /* altivec_lvrx */
    case 1220:  /* altivec_lvlxl */
    case 1219:  /* altivec_lvlx */
    case 1216:  /* *altivec_stvesfx */
    case 1215:  /* altivec_stvebx */
    case 1214:  /* altivec_stvehx */
    case 1213:  /* altivec_stvewx */
    case 1194:  /* altivec_lvsr */
    case 1193:  /* altivec_lvsl */
    case 1171:  /* altivec_vupklsh */
    case 1170:  /* altivec_vupklpx */
    case 1169:  /* altivec_vupklsb */
    case 1168:  /* altivec_vupkhsh */
    case 1167:  /* altivec_vupkhpx */
    case 1166:  /* altivec_vupkhsb */
    case 1158:  /* altivec_vrefp */
    case 1157:  /* *altivec_vrsqrtefp */
    case 1156:  /* altivec_vexptefp */
    case 1155:  /* altivec_vlogefp */
    case 1150:  /* *altivec_vrfim */
    case 1149:  /* altivec_vrfin */
    case 1148:  /* altivec_vrfip */
    case 856:  /* vsx_xvcvspuxds */
    case 855:  /* vsx_xvcvspsxds */
    case 854:  /* vsx_xvcvuxwdp */
    case 853:  /* vsx_xvcvsxwdp */
    case 852:  /* vsx_xvcvuxdsp */
    case 851:  /* vsx_xvcvsxdsp */
    case 850:  /* vsx_xvcvdpuxws */
    case 849:  /* vsx_xvcvdpsxws */
    case 848:  /* vsx_xscvspdp_scalar2 */
    case 847:  /* vsx_xscvdpsp_scalar */
    case 846:  /* vsx_xscvspdp */
    case 845:  /* vsx_xvcvdpsp */
    case 844:  /* vsx_xvcvspdp */
    case 843:  /* vsx_xscvdpsp */
    case 842:  /* vsx_ceilv2df2 */
    case 841:  /* vsx_ceilv4sf2 */
    case 840:  /* vsx_ceildf2 */
    case 839:  /* vsx_floorv2df2 */
    case 838:  /* vsx_floorv4sf2 */
    case 837:  /* vsx_floordf2 */
    case 836:  /* *vsx_b2truncv2df2 */
    case 835:  /* *vsx_b2truncv4sf2 */
    case 834:  /* *vsx_b2truncdf2 */
    case 830:  /* vsx_xvrdpic */
    case 829:  /* vsx_xvrspic */
    case 828:  /* vsx_xsrdpic */
    case 827:  /* vsx_xvrdpi */
    case 826:  /* vsx_xvrspi */
    case 825:  /* vsx_xsrdpi */
    case 770:  /* *vsx_tsqrtv2df2_internal */
    case 769:  /* *vsx_tsqrtv4sf2_internal */
    case 768:  /* *vsx_tsqrtdf2_internal */
    case 767:  /* *vsx_rsqrtev2df2 */
    case 766:  /* *vsx_rsqrtev4sf2 */
    case 765:  /* *vsx_rsqrtedf2 */
    case 744:  /* vsx_frev2df2 */
    case 743:  /* vsx_frev4sf2 */
    case 742:  /* vsx_fredf2 */
    case 705:  /* load_lockeddi */
    case 704:  /* load_lockedsi */
    case 536:  /* move_from_CR_ov_bit */
    case 440:  /* *tls_ld64 */
    case 439:  /* *tls_ld32 */
    case 287:  /* stfiwx */
    case 286:  /* rounddf2 */
    case 285:  /* roundsf2 */
    case 284:  /* *floordf2_fpr */
    case 283:  /* *floorsf2_fpr */
    case 282:  /* *ceildf2_fpr */
    case 281:  /* *ceilsf2_fpr */
    case 280:  /* *btruncdf2_fpr */
    case 279:  /* *btruncsf2_fpr */
    case 278:  /* lrintdfdi2 */
    case 277:  /* lrintsfdi2 */
    case 251:  /* lfiwzx */
    case 246:  /* lfiwax */
    case 238:  /* *rsqrtdf_internal1 */
    case 237:  /* *fred_fpr */
    case 217:  /* *rsqrtsf_internal1 */
    case 211:  /* fres */
    case 110:  /* paritydi2_cmpb */
    case 109:  /* paritysi2_cmpb */
    case 106:  /* popcntbdi2 */
    case 105:  /* popcntbsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 609:  /* *gtudi_compare */
    case 608:  /* *gtusi_compare */
    case 589:  /* *geudi_compare */
    case 588:  /* *geusi_compare */
    case 579:  /* *ltudi_compare */
    case 578:  /* *ltusi_compare */
    case 565:  /* *leudi_compare */
    case 564:  /* *leusi_compare */
    case 544:  /* *eqdi_compare */
    case 543:  /* *eqsi_compare */
    case 423:  /* *movdf_update1 */
    case 421:  /* *movsf_update3 */
    case 419:  /* *movsf_update1 */
    case 416:  /* *movqi_update1 */
    case 412:  /* *movhi_update1 */
    case 408:  /* *movsi_update1 */
    case 403:  /* *movdi_update1 */
    case 340:  /* *ashrdi3_internal3 */
    case 337:  /* *lshrdi3_internal3 */
    case 328:  /* *ashldi3_internal3 */
    case 313:  /* *rotldi3_internal3 */
    case 308:  /* *muldi3_internal2 */
    case 201:  /* *rs6000.md:4395 */
    case 188:  /* *rs6000.md:4081 */
    case 181:  /* *rs6000.md:3924 */
    case 168:  /* *rotlsi3_internal3 */
    case 131:  /* *rs6000.md:2574 */
    case 130:  /* *rs6000.md:2574 */
    case 121:  /* *mulsi3_internal2 */
    case 96:  /* *rs6000.md:1756 */
    case 95:  /* *rs6000.md:1756 */
    case 84:  /* *adddi3_internal3 */
    case 83:  /* *addsi3_internal3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 339:  /* *ashrdi3_internal2 */
    case 336:  /* *lshrdi3_internal2 */
    case 327:  /* *ashldi3_internal2 */
    case 312:  /* *rotldi3_internal2 */
    case 307:  /* *muldi3_internal1 */
    case 200:  /* *rs6000.md:4366 */
    case 187:  /* *rs6000.md:4050 */
    case 180:  /* *rs6000.md:3895 */
    case 167:  /* *rotlsi3_internal2 */
    case 129:  /* *rs6000.md:2545 */
    case 128:  /* *rs6000.md:2545 */
    case 120:  /* *mulsi3_internal1 */
    case 94:  /* *rs6000.md:1728 */
    case 93:  /* *rs6000.md:1728 */
    case 82:  /* *adddi3_internal2 */
    case 81:  /* *addsi3_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1256:  /* *cmptd_internal1 */
    case 1255:  /* *cmpdd_internal1 */
    case 1254:  /* divtd3 */
    case 1253:  /* divdd3 */
    case 1252:  /* multd3 */
    case 1251:  /* muldd3 */
    case 1250:  /* subtd3 */
    case 1249:  /* subdd3 */
    case 1248:  /* addtd3 */
    case 1247:  /* adddd3 */
    case 1118:  /* *altivec_vsrab */
    case 1117:  /* *altivec_vsrah */
    case 1116:  /* *altivec_vsraw */
    case 1115:  /* *altivec_vsrb */
    case 1114:  /* *altivec_vsrh */
    case 1113:  /* *altivec_vsrw */
    case 1112:  /* *altivec_vslb */
    case 1111:  /* *altivec_vslh */
    case 1110:  /* *altivec_vslw */
    case 1107:  /* *altivec_vrlb */
    case 1106:  /* *altivec_vrlh */
    case 1105:  /* *altivec_vrlw */
    case 1074:  /* *altivec_xorti3 */
    case 1073:  /* *altivec_xorv2di3 */
    case 1072:  /* *altivec_xorv2df3 */
    case 1071:  /* *altivec_xorv4sf3 */
    case 1070:  /* *altivec_xorv16qi3 */
    case 1069:  /* *altivec_xorv8hi3 */
    case 1068:  /* *altivec_xorv4si3 */
    case 1067:  /* *altivec_iorti3 */
    case 1066:  /* *altivec_iorv2di3 */
    case 1065:  /* *altivec_iorv2df3 */
    case 1064:  /* *altivec_iorv4sf3 */
    case 1063:  /* *altivec_iorv16qi3 */
    case 1062:  /* *altivec_iorv8hi3 */
    case 1061:  /* *altivec_iorv4si3 */
    case 1060:  /* *altivec_andti3 */
    case 1059:  /* *altivec_andv2di3 */
    case 1058:  /* *altivec_andv2df3 */
    case 1057:  /* *altivec_andv4sf3 */
    case 1056:  /* *altivec_andv16qi3 */
    case 1055:  /* *altivec_andv8hi3 */
    case 1054:  /* *altivec_andv4si3 */
    case 1034:  /* *altivec_sminv4sf3 */
    case 1033:  /* sminv16qi3 */
    case 1032:  /* sminv8hi3 */
    case 1031:  /* sminv4si3 */
    case 1030:  /* uminv16qi3 */
    case 1029:  /* uminv8hi3 */
    case 1028:  /* uminv4si3 */
    case 1027:  /* *altivec_smaxv4sf3 */
    case 1026:  /* smaxv16qi3 */
    case 1025:  /* smaxv8hi3 */
    case 1024:  /* smaxv4si3 */
    case 1023:  /* umaxv16qi3 */
    case 1022:  /* umaxv8hi3 */
    case 1021:  /* umaxv4si3 */
    case 997:  /* *altivec_gev4sf */
    case 996:  /* *altivec_gtv4sf */
    case 995:  /* *altivec_eqv4sf */
    case 994:  /* *altivec_gtuv16qi */
    case 993:  /* *altivec_gtuv8hi */
    case 992:  /* *altivec_gtuv4si */
    case 991:  /* *altivec_gtv16qi */
    case 990:  /* *altivec_gtv8hi */
    case 989:  /* *altivec_gtv4si */
    case 988:  /* *altivec_eqv16qi */
    case 987:  /* *altivec_eqv8hi */
    case 986:  /* *altivec_eqv4si */
    case 971:  /* *altivec_subv4sf3 */
    case 970:  /* subv16qi3 */
    case 969:  /* subv8hi3 */
    case 968:  /* subv4si3 */
    case 960:  /* *altivec_addv4sf3 */
    case 959:  /* addv16qi3 */
    case 958:  /* addv8hi3 */
    case 957:  /* addv4si3 */
    case 879:  /* *vsx_xorti3 */
    case 878:  /* *vsx_xorv2df3 */
    case 877:  /* *vsx_xorv4sf3 */
    case 876:  /* *vsx_xorv2di3 */
    case 875:  /* *vsx_xorv4si3 */
    case 874:  /* *vsx_xorv8hi3 */
    case 873:  /* *vsx_xorv16qi3 */
    case 872:  /* *vsx_iorti3 */
    case 871:  /* *vsx_iorv2df3 */
    case 870:  /* *vsx_iorv4sf3 */
    case 869:  /* *vsx_iorv2di3 */
    case 868:  /* *vsx_iorv4si3 */
    case 867:  /* *vsx_iorv8hi3 */
    case 866:  /* *vsx_iorv16qi3 */
    case 865:  /* *vsx_andti3 */
    case 864:  /* *vsx_andv2df3 */
    case 863:  /* *vsx_andv4sf3 */
    case 862:  /* *vsx_andv2di3 */
    case 861:  /* *vsx_andv4si3 */
    case 860:  /* *vsx_andv8hi3 */
    case 859:  /* *vsx_andv16qi3 */
    case 789:  /* *vsx_cmpdf_internal1 */
    case 788:  /* *vsx_gev2df */
    case 787:  /* *vsx_gev4sf */
    case 786:  /* vsx_gtv2df */
    case 785:  /* vsx_gtv4sf */
    case 784:  /* vsx_eqv2df */
    case 783:  /* vsx_eqv4sf */
    case 761:  /* *vsx_sminsf3 */
    case 760:  /* *vsx_smaxsf3 */
    case 759:  /* *vsx_sminv2df3 */
    case 758:  /* *vsx_sminv4sf3 */
    case 757:  /* *vsx_smindf3 */
    case 756:  /* vsx_smaxv2df3 */
    case 755:  /* vsx_smaxv4sf3 */
    case 754:  /* vsx_smaxdf3 */
    case 738:  /* *vsx_divv2df3 */
    case 737:  /* *vsx_divv4sf3 */
    case 736:  /* *vsx_divdf3 */
    case 735:  /* *vsx_mulv2df3 */
    case 734:  /* *vsx_mulv4sf3 */
    case 733:  /* *vsx_muldf3 */
    case 732:  /* *vsx_subv2df3 */
    case 731:  /* *vsx_subv4sf3 */
    case 730:  /* *vsx_subdf3 */
    case 729:  /* *vsx_addv2df3 */
    case 728:  /* *vsx_addv4sf3 */
    case 727:  /* *vsx_adddf3 */
    case 719:  /* *vector_unorderedv2df */
    case 718:  /* *vector_unorderedv4sf */
    case 717:  /* *vector_orderedv2df */
    case 716:  /* *vector_orderedv4sf */
    case 715:  /* *vector_ltgtv2df */
    case 714:  /* *vector_ltgtv4sf */
    case 713:  /* *vector_uneqv2df */
    case 712:  /* *vector_uneqv4sf */
    case 607:  /* *gtudi */
    case 606:  /* *gtusi */
    case 587:  /* *geudi */
    case 586:  /* *geusi */
    case 577:  /* *ltudi */
    case 576:  /* *ltusi */
    case 563:  /* *leudi */
    case 562:  /* *leusi */
    case 542:  /* *eqdi */
    case 541:  /* *eqsi */
    case 532:  /* *cmptf_internal1 */
    case 531:  /* *cmpdf_internal1 */
    case 530:  /* *cmpsf_internal1 */
    case 527:  /* *cmpdi_internal2 */
    case 526:  /* *cmpsi_internal2 */
    case 525:  /* *cmpdi_internal1 */
    case 524:  /* *cmpsi_internal1 */
    case 474:  /* elf_low */
    case 338:  /* *ashrdi3_internal1 */
    case 335:  /* *lshrdi3_internal1 */
    case 326:  /* *ashldi3_internal1 */
    case 311:  /* rotldi3 */
    case 306:  /* muldi3 */
    case 304:  /* ashrdi3_no_power */
    case 298:  /* *subdi3_noppc64 */
    case 297:  /* *adddi3_noppc64 */
    case 236:  /* *divdf3_fpr */
    case 235:  /* *muldf3_fpr */
    case 234:  /* *subdf3_fpr */
    case 233:  /* *adddf3_fpr */
    case 210:  /* *rs6000.md:4604 */
    case 209:  /* *rs6000.md:4588 */
    case 208:  /* *rs6000.md:4572 */
    case 207:  /* *rs6000.md:4556 */
    case 198:  /* ashrsi3 */
    case 185:  /* lshrsi3 */
    case 178:  /* ashlsi3 */
    case 165:  /* rotlsi3 */
    case 139:  /* *andsi3_internal6 */
    case 134:  /* andsi3_internal0_nomc */
    case 127:  /* *rs6000.md:2536 */
    case 126:  /* *rs6000.md:2536 */
    case 125:  /* *divdi3 */
    case 124:  /* *divsi3 */
    case 123:  /* udivdi3 */
    case 122:  /* udivsi3 */
    case 119:  /* mulsi3 */
    case 92:  /* *rs6000.md:1719 */
    case 91:  /* *rs6000.md:1719 */
    case 80:  /* *adddi3_internal1 */
    case 79:  /* *addsi3_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 78:  /* dlmzb */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 301:  /* umulsidi3 */
    case 300:  /* mulsidi3 */
    case 77:  /* *mullhwu */
    case 75:  /* *mullhw */
    case 73:  /* *mulhhwu */
    case 71:  /* *mulhhw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 76:  /* *mullhwuc */
    case 74:  /* *mullhwc */
    case 72:  /* *mulhhwuc */
    case 70:  /* *mulhhwc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 69:  /* *mulchwu */
    case 67:  /* *mulchw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 68:  /* *mulchwuc */
    case 66:  /* *mulchwc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 65:  /* *nmaclhw */
    case 63:  /* *nmachhw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 64:  /* *nmaclhwc */
    case 62:  /* *nmachhwc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 4;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1), 0);
      recog_data.dup_num[2] = 2;
      break;

    case 61:  /* *nmacchw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 60:  /* *nmacchwc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 4;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1), 0);
      recog_data.dup_num[2] = 1;
      break;

    case 59:  /* *maclhwu */
    case 57:  /* *maclhw */
    case 55:  /* *machhwu */
    case 53:  /* *machhw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 58:  /* *maclhwuc */
    case 56:  /* *maclhwc */
    case 54:  /* *machhwuc */
    case 52:  /* *machhwc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 4;
      break;

    case 51:  /* *macchwu */
    case 49:  /* *macchw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 50:  /* *macchwuc */
    case 48:  /* *macchwc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 4;
      break;

    case 102:  /* *rs6000.md:1840 */
    case 101:  /* *rs6000.md:1840 */
    case 90:  /* *rs6000.md:1692 */
    case 89:  /* *rs6000.md:1692 */
    case 47:  /* *rs6000.md:952 */
    case 43:  /* *rs6000.md:878 */
    case 40:  /* *rs6000.md:811 */
    case 37:  /* *rs6000.md:752 */
    case 34:  /* *rs6000.md:691 */
    case 31:  /* *rs6000.md:632 */
    case 28:  /* *rs6000.md:565 */
    case 24:  /* *rs6000.md:491 */
    case 20:  /* *rs6000.md:417 */
    case 17:  /* *zero_extendsidi2_internal3 */
    case 16:  /* *zero_extendhidi2_internal3 */
    case 15:  /* *zero_extendqidi2_internal3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 255:  /* floatunssidf2_lfiwzx_mem */
    case 254:  /* floatunssisf2_lfiwzx_mem */
    case 250:  /* floatsidf2_lfiwax_mem */
    case 249:  /* floatsisf2_lfiwax_mem */
    case 100:  /* *rs6000.md:1815 */
    case 99:  /* *rs6000.md:1815 */
    case 88:  /* *rs6000.md:1667 */
    case 87:  /* *rs6000.md:1667 */
    case 46:  /* *rs6000.md:927 */
    case 42:  /* *rs6000.md:853 */
    case 39:  /* *rs6000.md:786 */
    case 36:  /* *rs6000.md:727 */
    case 33:  /* *rs6000.md:666 */
    case 30:  /* *rs6000.md:607 */
    case 27:  /* *rs6000.md:540 */
    case 23:  /* *rs6000.md:466 */
    case 19:  /* *rs6000.md:392 */
    case 14:  /* *zero_extendsidi2_internal2 */
    case 13:  /* *zero_extendhidi2_internal2 */
    case 12:  /* *zero_extendqidi2_internal2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1262:  /* fixtddi2 */
    case 1261:  /* ftrunctd2 */
    case 1260:  /* fixdddi2 */
    case 1259:  /* ftruncdd2 */
    case 1258:  /* floatditd2 */
    case 1257:  /* floatdidd2 */
    case 1245:  /* extendddtd2 */
    case 1242:  /* *abstd2_fpr */
    case 1241:  /* *negtd2_fpr */
    case 1234:  /* *absdd2_fpr */
    case 1233:  /* *negdd2_fpr */
    case 1232:  /* truncddsd2 */
    case 1231:  /* extendsddd2 */
    case 1133:  /* *altivec_vrfiz */
    case 1132:  /* altivec_vspltisb */
    case 1131:  /* altivec_vspltish */
    case 1130:  /* altivec_vspltisw */
    case 1081:  /* *altivec_one_cmplti2 */
    case 1080:  /* *altivec_one_cmplv2di2 */
    case 1079:  /* *altivec_one_cmplv2df2 */
    case 1078:  /* *altivec_one_cmplv4sf2 */
    case 1077:  /* *altivec_one_cmplv16qi2 */
    case 1076:  /* *altivec_one_cmplv8hi2 */
    case 1075:  /* *altivec_one_cmplv4si2 */
    case 914:  /* vsx_splat_v2di */
    case 913:  /* vsx_splat_v2df */
    case 909:  /* *vsx_extract_v2di_zero */
    case 908:  /* *vsx_extract_v2df_zero */
    case 886:  /* *vsx_one_cmplti2 */
    case 885:  /* *vsx_one_cmplv2df2 */
    case 884:  /* *vsx_one_cmplv4sf2 */
    case 883:  /* *vsx_one_cmplv2di2 */
    case 882:  /* *vsx_one_cmplv4si2 */
    case 881:  /* *vsx_one_cmplv8hi2 */
    case 880:  /* *vsx_one_cmplv16qi2 */
    case 833:  /* vsx_btruncv2df2 */
    case 832:  /* vsx_btruncv4sf2 */
    case 831:  /* vsx_btruncdf2 */
    case 824:  /* vsx_fixuns_truncv2dfv2di2 */
    case 823:  /* vsx_fixuns_truncv4sfv4si2 */
    case 822:  /* vsx_fixuns_truncdfdi2 */
    case 821:  /* vsx_fix_truncv2dfv2di2 */
    case 820:  /* vsx_fix_truncv4sfv4si2 */
    case 819:  /* vsx_fix_truncdfdi2 */
    case 818:  /* vsx_floatunsv2div2df2 */
    case 817:  /* vsx_floatunsv4siv4sf2 */
    case 816:  /* vsx_floatunsdidf2 */
    case 815:  /* vsx_floatv2div2df2 */
    case 814:  /* vsx_floatv4siv4sf2 */
    case 813:  /* vsx_floatdidf2 */
    case 764:  /* *vsx_sqrtv2df2 */
    case 763:  /* *vsx_sqrtv4sf2 */
    case 762:  /* *vsx_sqrtdf2 */
    case 750:  /* *vsx_absv2df2 */
    case 749:  /* *vsx_absv4sf2 */
    case 748:  /* *vsx_absdf2 */
    case 747:  /* *vsx_negv2df2 */
    case 746:  /* *vsx_negv4sf2 */
    case 745:  /* *vsx_negdf2 */
    case 711:  /* *vec_reload_and_reg_di */
    case 710:  /* *vec_reload_and_reg_si */
    case 473:  /* elf_high */
    case 376:  /* negtf2_internal */
    case 372:  /* trunctfdf2_internal2 */
    case 371:  /* trunctfdf2_internal1 */
    case 299:  /* *negdi2_noppc64 */
    case 295:  /* floatunsdisf2_fcfidus */
    case 292:  /* floatdisf2_fcfids */
    case 290:  /* *floatunsdidf2_fcfidu */
    case 288:  /* *floatdidf2_fpr */
    case 267:  /* *fixuns_truncdfdi2_fctiduz */
    case 266:  /* *fixuns_truncsfdi2_fctiduz */
    case 263:  /* *fix_truncdfdi2_fctidz */
    case 262:  /* *fix_truncsfdi2_fctidz */
    case 243:  /* *sqrtdf2_fpr */
    case 231:  /* *absdf2_fpr */
    case 230:  /* *negdf2_fpr */
    case 216:  /* *rs6000.md:4669 */
    case 205:  /* *abssf2 */
    case 204:  /* *negsf2 */
    case 203:  /* *truncdfsf2_fpr */
    case 202:  /* *extendsfdf2_fpr */
    case 115:  /* *bswapsi2_internal */
    case 108:  /* popcntddi2 */
    case 107:  /* popcntdsi2 */
    case 104:  /* clzdi2 */
    case 103:  /* clzsi2 */
    case 98:  /* *negdi2_internal */
    case 97:  /* *negsi2_internal */
    case 86:  /* one_cmpldi2 */
    case 85:  /* one_cmplsi2 */
    case 45:  /* *rs6000.md:920 */
    case 44:  /* *rs6000.md:911 */
    case 41:  /* *rs6000.md:844 */
    case 38:  /* extendqihi2 */
    case 35:  /* *rs6000.md:718 */
    case 32:  /* extendqisi2 */
    case 29:  /* *rs6000.md:598 */
    case 26:  /* *rs6000.md:533 */
    case 25:  /* *rs6000.md:524 */
    case 22:  /* *rs6000.md:459 */
    case 21:  /* *rs6000.md:450 */
    case 18:  /* extendqidi2 */
    case 11:  /* *zero_extendsidi2_internal1 */
    case 10:  /* *zero_extendhidi2_internal1 */
    case 9:  /* *zero_extendqidi2_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 555:  /* *plus_ne0_di */
    case 554:  /* *plus_ne0_si */
    case 514:  /* *sibcall_value_nonlocal_sysvdi */
    case 513:  /* *sibcall_value_nonlocal_sysvsi */
    case 510:  /* *sibcall_value_nonlocal_aixdi */
    case 509:  /* *sibcall_value_nonlocal_aixsi */
    case 506:  /* *sibcall_value_local64 */
    case 505:  /* *sibcall_value_local32 */
    case 500:  /* *call_value_nonlocal_sysvdi */
    case 499:  /* *call_value_nonlocal_sysvsi */
    case 498:  /* *call_value_indirect_nonlocal_sysvdi */
    case 497:  /* *call_value_indirect_nonlocal_sysvsi */
    case 490:  /* *call_value_nonlocal_aix64 */
    case 489:  /* *call_value_nonlocal_aix32 */
    case 478:  /* *call_value_local64 */
    case 477:  /* *call_value_local32 */
    case 8:  /* *call_value_nonlocal_darwin64 */
    case 7:  /* *call_value_indirect_nonlocal_darwin64 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 512:  /* *sibcall_nonlocal_sysvdi */
    case 511:  /* *sibcall_nonlocal_sysvsi */
    case 508:  /* *sibcall_nonlocal_aixdi */
    case 507:  /* *sibcall_nonlocal_aixsi */
    case 504:  /* *sibcall_local64 */
    case 503:  /* *sibcall_local32 */
    case 494:  /* *call_nonlocal_sysvdi */
    case 493:  /* *call_nonlocal_sysvsi */
    case 492:  /* *call_indirect_nonlocal_sysvdi */
    case 491:  /* *call_indirect_nonlocal_sysvsi */
    case 488:  /* *call_nonlocal_aix64 */
    case 487:  /* *call_nonlocal_aix32 */
    case 476:  /* *call_local64 */
    case 475:  /* *call_local32 */
    case 6:  /* *call_nonlocal_darwin64 */
    case 5:  /* *call_indirect_nonlocal_darwin64 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 4:  /* macho_correct_pic_di */
    case 3:  /* macho_correct_pic_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 1185:  /* altivec_mtvscr */
    case 2:  /* load_macho_picbase_di */
    case 1:  /* load_macho_picbase_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    }
}
